/* Shader code by Vade + Laserpilot */
/* Quickly ported to Gem with some adjustments */
/* http://puredata.hurleur.com/sujet-8657-single-pixel-manipulation */


/* Texture input */
uniform sampler2D tex0;
uniform sampler2D tex1; 	// bars and distortion texture

/* Uniform */
uniform vec2 texdim0; // texture dimension
uniform float barsamount;	// changes bars amount
uniform float distortion;	// amount of distortion
uniform float resolution;		// for scanlines
uniform float vsync;		// sync
uniform float hsync;

uniform float value;

void main (void) 
{ 	
	vec2 point = gl_TexCoord[0].st / texdim0;
	vec2 original = point;

	vec4 bars = texture2D(tex1, gl_TexCoord[0].st);

	// scanlines
	vec4 stripes; // our base 'stripe color'
	/* stripes = vec4(floor(mod(gl_TexCoord[0].t * texdim0.t, resolution+0.0001)));
	stripes = clamp(stripes, 0.0, 1.0);
	stripes = 2.0 - (stripes - vec4(0.0)); // subtract 
	*/
	
	stripes = vec4(floor(mod(gl_TexCoord[0].t * texdim0.t, resolution+0.0001)));
	stripes = clamp(stripes, 0.0, 1.0);
	stripes = 2.0 - (stripes - vec4(0.0)); // subtract 
	//stripes = clamp(stripes, 0.0, 1.0);
	//stripes = 2.0 - (stripes - vec4(0.0)); // subtract 
	
	
	// get rough luma 
	vec4 key = texture2D(tex0, (vec2(point.y, point.y)) * texdim0);
	key += texture2D(tex0, (1.0 - vec2(point.y, point.y)) * texdim0);
	key -= bars.r;
	float d = key.r + key.g + key.b;
	d /= 3.0;
	point.x -= d * distortion * 0.1;	

	//sync			
	vec2 texcoord = point + ( mod(vec2(hsync, vsync), 1.0)); 
	
	// wrap
	texcoord = mod(texcoord, 1.0);
	
	// output
	vec4 result = stripes * texture2D(tex0, texcoord * texdim0);
	gl_FragColor = mix(result, bars*result, barsamount);
} 




